import $ from 'jquery';
// import 'jquery-validation';

const Form = (($) => {
  const NAME = 'form';
  const DATA_KEY = 'fuc.form';
  const EVENT_KEY = `.${DATA_KEY}`;
  const DATA_API_KEY = '.data-api';
  const JQUERY_NO_CONFLICT = $.fn[NAME];

  const ClassName = {
    active: 'active',
    FORM: 'fuc-form',
  };

  const Selector = {
    DATA_TOGGLE_CARROT: '[data-toggle^="form"]',
    FORM: '.fuc-form',
  };

  const Event = {
    CLICK_DATA_API: `click${EVENT_KEY}${DATA_API_KEY}`,
  };

  class Form {
    constructor(element) {
      this._element = element;
    }

    // Public
    active() {
      $(this._element).addClass(ClassName.active);
    }

    // Static
    static _jQueryInterface(config) {
      return this.each(function () {
        let data = $(this).data(DATA_KEY);

        if (!data) {
          data = new Form(this, config);
          $(this).data(DATA_KEY, data);
        }

        if (config === 'active') {
          data[config]();
        }
      });
    }
  }

  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */

  $(document)
    .on(Event.CLICK_DATA_API, Selector.DATA_TOGGLE_CARROT, (event) => {
      event.preventDefault();

      let form = event.target;

      if (!$(form).hasClass(ClassName.FORM)) {
        form = $(form).closest(Selector.FORM);
      }

      Form._jQueryInterface.call($(form), 'toggle');
    });

  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   */

  $.fn[NAME] = Form._jQueryInterface;
  $.fn[NAME].Constructor = Form;
  $.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Form._jQueryInterface;
  };

  return Form;
})($);

export default Form;
